#include <iostream>
#include <fstream>
#include <string>
#include <sstream>
#include <iomanip>

#include "edc.h"

using namespace std;

fstream f;
float dataz();

Edc::Edc(void) {  } //Implementation des Konstruktors

void Edc::load(char source[])
{
    f.open( source , ios::in);  // ffnen der Quelldatei
    channels = int(dataz());  // erste Zeile ist Anzahl der Datenzeilen
    for(int i=0; i<channels; i++)  // Einlesen der Messwerte
    {
        data[1][i] = dataz();
    }
    f.close();
  	Emin = 0;
	Emax = 20;
    yMin = 0;
	yMax = 1;
	for(int i=0; i <= channels ; i++)
	{
		if(yMin > data[1][i]) yMin = data[1][i];
		if(yMax < data[1][i]) yMax = data[1][i];
	}
}

void Edc::init()
{
    srand(5);
    channels = 200;
	Emin = 0;
	Emax = 20;
	yMin = 0;
	yMax = 1;
	for(int i=0; i <= channels ; i++)
	{
	    data[0][i] = float(i)/10;
		data[1][i] = rand()%800+200;
		if(yMin > data[1][i]) yMin = data[1][i];
		if(yMax < data[1][i]) yMax = data[1][i];
	}
}

void Edc::smooth()
{
// do something
  int mean1 = 0 , mean2 = 0;
  for(int i=0;i<5;i++)  //              Rnder 5 Pixel Noise auf 10 % senken
  {
    mean1 += int(data[1][i]);
    mean2 += int(data[1][channels-i]);
  }
  mean1 = int (mean1 * 9 / 50);
  mean2 = int (mean2 * 9 / 50);
  for(int i=1;i<5;i++)
  {
    data[1][i] = mean1 + data[1][i]/10;
    data[1][channels-i] = mean2 + data[1][channels-i]/10;
  }
  int maximum = 0;
  int maxatE = 0;
  for(int i=5;i<channels-5;i++) //        alle Daten gltten
  {
    data[1][i] = (6*data[1][i] + 4*(data[1][i-1]+data[1][i+1]) +
                  2*(data[1][i-2]+data[1][i-3]+data[1][i+2]+data[1][i+3]) +
                  (data[1][i-4]+data[1][i-5]+data[1][i+4]+data[1][i+5]))/ 26;
    if(data[1][i] > maximum)
    {
      maximum = int(data[1][i]);
      maxatE = i;
    }
  }
}

void Edc::spikes()
{
// do something
}

void Edc::shirley() 
{
// do something
}

float dataz()
{
  char datastrg[256]="";
  float valuez=0;
  if(!f.eof()) { f.getline (datastrg,sizeof(datastrg)); }
  istringstream istr (datastrg);
  istr >> valuez;
  return valuez;
}
