    #ifndef MAINWINDOW_H
    #define MAINWINDOW_H

    #include <QMainWindow>
	#include "edc.h"

	class QSlider;
	
    class MainWindow : public QMainWindow
    {
        Q_OBJECT

    public:
        MainWindow();
		int variableG;

	signals:
		void valueChanged(int newValue);
		void updateSpec(int,float,float,float,float,float*);
		
	public slots:
		void slotLoad();
		void slotSmooth();
		void slotSpikes();
		void slotShirley();
		void slotSave();
		
private slots:
    void newFile();
    void open();
    bool save();
    bool saveAs();
    void about();
    void documentWasModified();
		
private:
	QSlider *slider;
    void submit();
	void createButtons();
	void createActions();
    void createMenus();
        void createToolBars();
        void createStatusBar();
        void readSettings();
        void writeSettings();
        bool maybeSave();
        void loadFile(const QString &fileName);
        bool saveFile(const QString &fileName);
        void setCurrentFile(const QString &fileName);
        QString strippedName(const QString &fullFileName);

        QString curFile;

        QMenu *fileMenu;
        QMenu *editMenu;
        QMenu *helpMenu;
        QToolBar *fileToolBar;
        QToolBar *editToolBar;
        QAction *newAct;
        QAction *openAct;
        QAction *saveAct;
        QAction *saveAsAct;
        QAction *exitAct;
        QAction *cutAct;
        QAction *copyAct;
        QAction *pasteAct;
        QAction *aboutAct;
        QAction *aboutQtAct;
		
    }; 
	 
    #endif
