    #include <QPaintEvent>
    #include <QPainter>

    #include "spektrum.h"
	
    Spektrum::Spektrum(QWidget *parent)        : QWidget(parent)
    {
        setPalette(QPalette(QColor(255, 255, 255)));
        setAutoFillBackground(true);
    }

    void Spektrum::paintEvent(QPaintEvent * /* event */)
    {
        QPainter painter(this);
		QPen pen(Qt::black, 1, Qt::SolidLine, Qt::RoundCap, Qt::RoundJoin);
        painter.setPen(pen);
        painter.translate(0, rect().height());
		painter.drawLine(5, -15, rect().width()-5, -15);
		painter.drawText(20, -(rect().height()-15), tr("Kanle: ") + QString::number(channels) + 
		" - Emin: " + QString::number(xMin) + " - Emax: " + QString::number(xMax) + 
		" - Ymin: " + QString::number(yMin) + " - Ymax: " + QString::number(yMax) );
		painter.translate(15, -15); /*Koordinatenursprung fr Spektrum setzen */
		scaleY = (rect().height()-20)/ yMax;
		scaleX = (float(rect().width()-20))/float(channels);
		for(int x = 0; x < channels; x++)
		{
		    painter.drawLine(int((x+1)*scaleX),-(int(intensity[x+1]*scaleY)),int(x*scaleX),-(int(intensity[x]*scaleY)));
		}
    }

void Spektrum::reload(int dimX, float minX, float maxX, float minY, float maxY, float *daten)
{
    channels = dimX;
	xMin = minX;
    xMax = maxX;
	yMin = minY;
	yMax = maxY;
	for(int i=0;i<=channels;i++) {intensity[i]=daten[i];}
	update();
}

void Spektrum::neuerung(int zahl) 
{
    channels = zahl;
	update();
}
